"use strict";

var isStickySupported = "boolean" == typeof /./g.sticky, _pattern = function(a) {
  if ("function" == typeof a) {
    return a;
  }
  a = "string" != typeof a ? a.source : a;
  return isStickySupported ? new RegExp(a, "y") : new RegExp("^(?:" + a + ")", "g");
}, _exec = function(a, d) {
  if ("function" == typeof d) {
    return d();
  }
  if (isStickySupported) {
    d.lastIndex = a.index;
    var b = d.exec(a.input);
    a.index = d.lastIndex;
  } else {
    d.lastIndex = 0, b = d.exec(a.input.slice(a.input)), a.index += d.lastIndex;
  }
  return b && b[0];
}, tag = function(a, d) {
  a.tag = d;
  return a;
}, _ignored_expression = _pattern(/([\s,]|#[^\n\r]+)+/), ignored = function(a) {
  var b, d = a.index, c = [];
  if (b = _exec(a, _ignored_expression)) {
    return c.push(b), tag(c, "ignored");
  }
  a.index = d;
}, _Name_expression = _pattern(/[_\w][_\d\w]*/), name = function(a) {
  var b, d = a.index, c = [];
  if (b = _exec(a, _Name_expression)) {
    return c.push(b), function(a) {
      return {
        kind: a.tag,
        value: a[0]
      };
    }(tag(c, "Name"));
  }
  a.index = d;
}, _NullValue_expression = _pattern(/null/), _BooleanValue_expression = _pattern(/true|false/), _Variable_expression = _pattern(/[$]/), variable = function(a) {
  var b, d = a.index, c = [];
  if (_exec(a, _Variable_expression) && (b = name(a))) {
    return c.push(b), function(a) {
      return {
        kind: a.tag,
        value: a[0]
      };
    }(tag(c, "Variable"));
  }
  a.index = d;
}, _Number_expression = _pattern(/[-]?\d+/), _Number_expression2 = _pattern(/[.]\d+/), _Number_expression3 = _pattern(/[eE][+-]?\d+/), _StringValue_expression = _pattern(/"""/), _StringValue_expression2 = _pattern(/.*(?=""")/), _StringValue_expression3 = _pattern(/"""/), _StringValue_expression4 = _pattern(/"/), _StringValue_expression5 = _pattern(/[^"\r\n]*/), _StringValue_expression6 = _pattern(/"/), _StringValue_transform = function(a) {
  return {
    kind: a.tag,
    value: a[0]
  };
}, _ListValue_expression = _pattern(/\[/), _ListValue_expression2 = _pattern(/\]/), _ObjectField_expression = _pattern(/:/), objectField = function(a) {
  var b, d = a.index, c = [];
  if (b = name(a)) {
    if (c.push(b), b = a.index, ignored(a) || (a.index = b), _exec(a, _ObjectField_expression) || (a.index = b), 
    ignored(a) || (a.index = b), b = value(a)) {
      return c.push(b), b = a.index, ignored(a) || (a.index = b), function(a) {
        return {
          kind: a.tag,
          name: a[0],
          value: a[1]
        };
      }(tag(c, "ObjectField"));
    }
  }
  a.index = d;
}, _ObjectValue_expression = _pattern(/{/), _ObjectValue_expression2 = _pattern(/}/), value = function(a) {
  var b, d = a.index, c = [], e = c.length;
  a: {
    var f = a.index;
    if (b = function(a) {
      var b, d = a.index, c = [];
      if (b = _exec(a, _NullValue_expression)) {
        return c.push(b), function(a) {
          return {
            kind: a.tag,
            value: null
          };
        }(tag(c, "NullValue"));
      }
      a.index = d;
    }(a)) {
      c.push(b);
      break a;
    } else {
      c.length = e, a.index = f;
    }
    f = a.index;
    if (b = function(a) {
      var b, d = a.index, c = [];
      if (b = _exec(a, _BooleanValue_expression)) {
        return c.push(b), function(a) {
          return {
            kind: a.tag,
            value: "true" === a
          };
        }(tag(c, "BooleanValue"));
      }
      a.index = d;
    }(a)) {
      c.push(b);
      break a;
    } else {
      c.length = e, a.index = f;
    }
    f = a.index;
    if (b = variable(a)) {
      c.push(b);
      break a;
    } else {
      c.length = e, a.index = f;
    }
    f = a.index;
    if (b = function(a) {
      var b, d = a.index, c = [];
      var e = a.index, f = c.length;
      if (_exec(a, _StringValue_expression) && (b = _exec(a, _StringValue_expression2)) && (c.push(b), 
      _exec(a, _StringValue_expression3))) {
        return _StringValue_transform(tag(c, "StringValue"));
      }
      c.length = f;
      a.index = e;
      f = c.length;
      if (_exec(a, _StringValue_expression4) && (b = _exec(a, _StringValue_expression5)) && (c.push(b), 
      _exec(a, _StringValue_expression6))) {
        return _StringValue_transform(tag(c, "StringValue"));
      }
      c.length = f;
      a.index = d;
    }(a)) {
      c.push(b);
      break a;
    } else {
      c.length = e, a.index = f;
    }
    f = a.index;
    if (b = function(a) {
      var b, d = a.index, c = [];
      if (b = _exec(a, _Number_expression)) {
        return c.push(b), d = a.index, (b = _exec(a, _Number_expression2)) ? c.push(b) : a.index = d, 
        d = a.index, (b = _exec(a, _Number_expression3)) ? c.push(b) : a.index = d, function(a) {
          return {
            kind: 1 === a.length ? "IntValue" : "FloatValue",
            value: a.join("")
          };
        }(tag(c, "Number"));
      }
      a.index = d;
    }(a)) {
      c.push(b);
      break a;
    } else {
      c.length = e, a.index = f;
    }
    f = a.index;
    if (b = function(a) {
      var b, d = a.index, c = [];
      if (b = name(a)) {
        return c.push(b), function(a) {
          return {
            kind: a.tag,
            value: a[0].value
          };
        }(tag(c, "EnumValue"));
      }
      a.index = d;
    }(a)) {
      c.push(b);
      break a;
    } else {
      c.length = e, a.index = f;
    }
    f = a.index;
    if (b = function(a) {
      var d = a.index, b = [];
      if (_exec(a, _ListValue_expression)) {
        var c = a.index;
        ignored(a) || (a.index = c);
        a: for (;;) {
          var e = a.index;
          if (c = value(a)) {
            b.push(c);
          } else {
            a.index = e;
            break a;
          }
        }
        if (_exec(a, _ListValue_expression2)) {
          return c = a.index, ignored(a) || (a.index = c), function(a) {
            return {
              kind: a.tag,
              values: a
            };
          }(tag(b, "ListValue"));
        }
      }
      a.index = d;
    }(a)) {
      c.push(b);
      break a;
    } else {
      c.length = e, a.index = f;
    }
    if (b = function(a) {
      var d = a.index, b = [];
      if (_exec(a, _ObjectValue_expression)) {
        var c = a.index;
        ignored(a) || (a.index = c);
        a: for (;;) {
          var e = a.index;
          if (c = objectField(a)) {
            b.push(c);
          } else {
            a.index = e;
            break a;
          }
        }
        if (_exec(a, _ObjectValue_expression2)) {
          return c = a.index, ignored(a) || (a.index = c), function(a) {
            return {
              kind: a.tag,
              fields: a
            };
          }(tag(b, "ObjectValue"));
        }
      }
      a.index = d;
    }(a)) {
      c.push(b);
    } else {
      c.length = e;
      a.index = d;
      return;
    }
  }
  d = a.index;
  ignored(a) || (a.index = d);
  return function(a) {
    return a[0];
  }(tag(c, "value"));
}, _Argument_expression = _pattern(/:/), arg = function(a) {
  var b, d = a.index, c = [];
  if (b = name(a)) {
    if (c.push(b), b = a.index, ignored(a) || (a.index = b), _exec(a, _Argument_expression) && (b = a.index, 
    ignored(a) || (a.index = b), b = value(a))) {
      return c.push(b), function(a) {
        return {
          kind: a.tag,
          name: a[0],
          value: a[1]
        };
      }(tag(c, "Argument"));
    }
  }
  a.index = d;
}, _ArgumentSet_expression = _pattern(/\(/), _ArgumentSet_expression2 = _pattern(/\)/), args = function(a) {
  var d = [], b = a.index;
  _exec(a, _ArgumentSet_expression) || (a.index = b);
  var c = a.index;
  ignored(a) || (a.index = c);
  var e = 0;
  a: for (;;e++) {
    var f = a.index;
    if (c = arg(a)) {
      d.push(c);
    } else {
      if (e) {
        a.index = f;
        break a;
      }
      a.index = b;
    }
  }
  _exec(a, _ArgumentSet_expression2) || (a.index = b);
  c = a.index;
  ignored(a) || (a.index = c);
  return tag(d, "ArgumentSet");
}, _Directive_expression = _pattern(/@/), directive = function(a) {
  var b, d = a.index, c = [];
  if (_exec(a, _Directive_expression) && (b = name(a))) {
    return c.push(b), d = a.index, ignored(a) || (a.index = d), d = a.index, (b = args(a)) ? c.push(b) : a.index = d, 
    d = a.index, ignored(a) || (a.index = d), function(a) {
      return {
        kind: a.tag,
        name: a[0],
        arguments: a[1]
      };
    }(tag(c, "Directive"));
  }
  a.index = d;
}, directives = function(a) {
  var d, b = [], c = a.index;
  ignored(a) || (a.index = c);
  a: for (;;) {
    if (c = a.index, d = directive(a)) {
      b.push(d);
    } else {
      a.index = c;
      break a;
    }
  }
  return tag(b, "DirectiveSet");
}, _Field_expression = _pattern(/:/), field = function(a) {
  var b, d = a.index, c = [];
  if (b = name(a)) {
    c.push(b);
    var e = a.index;
    ignored(a) || (a.index = e);
    e = a.index;
    _exec(a, _Field_expression) || (a.index = e);
    var f = a.index;
    ignored(a) || (a.index = f);
    (b = name(a)) ? c.push(b) : a.index = e;
    e = a.index;
    ignored(a) || (a.index = e);
    if (b = args(a)) {
      if (c.push(b), b = directives(a)) {
        return c.push(b), e = a.index, (b = selectionSet(a)) ? c.push(b) : a.index = e, 
        function(a) {
          var d = 0;
          return {
            kind: a.tag,
            alias: "Name" === a[1].kind ? a[d++] : void 0,
            name: a[d++],
            arguments: a[d++],
            directives: a[d++],
            selectionSet: a[d++]
          };
        }(tag(c, "Field"));
      }
    }
  }
  a.index = d;
}, _Type_expression = _pattern(/\[/), _Type_expression2 = _pattern(/\]/), _Type_expression3 = _pattern(/!/), type = function(a) {
  var b, d = a.index, c = [], e = c.length;
  a: {
    var f = a.index;
    if (_exec(a, _Type_expression)) {
      var g = a.index;
      ignored(a) || (a.index = g);
      if (b = type(a)) {
        if (c.push(b), g = a.index, ignored(a) || (a.index = g), _exec(a, _Type_expression2)) {
          g = a.index;
          ignored(a) || (a.index = g);
          break a;
        } else {
          c.length = e, a.index = f;
        }
      } else {
        c.length = e, a.index = f;
      }
    } else {
      c.length = e, a.index = f;
    }
    if (b = name(a)) {
      c.push(b);
    } else {
      c.length = e;
      a.index = d;
      return;
    }
  }
  d = a.index;
  (b = _exec(a, _Type_expression3)) ? c.push(b) : a.index = d;
  d = a.index;
  ignored(a) || (a.index = d);
  return function(a) {
    var d = "Name" === a[0].kind ? {
      kind: "NamedType",
      name: a[0]
    } : {
      kind: "ListType",
      type: a[0]
    };
    return "!" === a[1] ? {
      kind: "NonNullType",
      type: d
    } : d;
  }(tag(c, "Type"));
}, _TypeCondition_expression = _pattern(/on/), typeCondition = function(a) {
  var b, d = a.index, c = [];
  if (_exec(a, _TypeCondition_expression) && ignored(a) && (b = name(a))) {
    return c.push(b), d = a.index, ignored(a) || (a.index = d), function(a) {
      return {
        kind: "NamedType",
        name: a[0]
      };
    }(tag(c, "TypeCondition"));
  }
  a.index = d;
}, _InlineFragment_expression = _pattern(/\.\.\./), inlineFragment = function(a) {
  var d = a.index, b = [];
  if (_exec(a, _InlineFragment_expression)) {
    var c = a.index;
    ignored(a) || (a.index = c);
    if (c = typeCondition(a)) {
      if (b.push(c), c = directives(a)) {
        if (b.push(c), c = selectionSet(a)) {
          return b.push(c), function(a) {
            return {
              kind: a.tag,
              typeCondition: a[0],
              directives: a[1],
              selectionSet: a[2]
            };
          }(tag(b, "InlineFragment"));
        }
      }
    }
  }
  a.index = d;
}, _FragmentSpread_expression = _pattern(/\.\.\./), fragmentSpread = function(a) {
  var d = a.index, b = [];
  if (_exec(a, _FragmentSpread_expression)) {
    var c = a.index;
    ignored(a) || (a.index = c);
    if (c = name(a)) {
      if (b.push(c), c = a.index, ignored(a) || (a.index = c), c = directives(a)) {
        return b.push(c), function(a) {
          return {
            kind: a.tag,
            name: a[0],
            directives: a[1]
          };
        }(tag(b, "FragmentSpread"));
      }
    }
  }
  a.index = d;
}, _SelectionSet_expression = _pattern(/{/), _SelectionSet_expression2 = _pattern(/}/), selectionSet = function(a) {
  var b, d = a.index, c = [];
  if (_exec(a, _SelectionSet_expression)) {
    var e = a.index;
    ignored(a) || (a.index = e);
    var f = 0;
    a: for (;;f++) {
      var g = a.index, h = c.length;
      b: {
        e = a.index;
        if (b = inlineFragment(a)) {
          c.push(b);
          break b;
        } else {
          c.length = h, a.index = e;
        }
        e = a.index;
        if (b = fragmentSpread(a)) {
          c.push(b);
          break b;
        } else {
          c.length = h, a.index = e;
        }
        if (b = field(a)) {
          c.push(b);
        } else {
          if (f) {
            a.index = g;
            break a;
          }
          c.length = h;
          a.index = d;
          return;
        }
      }
    }
    if (_exec(a, _SelectionSet_expression2)) {
      return e = a.index, ignored(a) || (a.index = e), function(a) {
        return {
          kind: a.tag,
          selections: a
        };
      }(tag(c, "SelectionSet"));
    }
  }
  a.index = d;
}, _VariableDefinitionDefault_expression = _pattern(/[=]/), _VariableDefinition_expression = _pattern(/:/), varDefinition = function(a) {
  var b, d = a.index, c = [];
  if (b = variable(a)) {
    if (c.push(b), b = a.index, ignored(a) || (a.index = b), _exec(a, _VariableDefinition_expression) && (b = a.index, 
    ignored(a) || (a.index = b), b = type(a))) {
      c.push(b);
      var e = a.index;
      (b = function(a) {
        var d = a.index, b = [];
        if (_exec(a, _VariableDefinitionDefault_expression)) {
          var c = a.index;
          ignored(a) || (a.index = c);
          if (c = value(a)) {
            return b.push(c), function(a) {
              return a[0];
            }(tag(b, "VariableDefinitionDefault"));
          }
        }
        a.index = d;
      }(a)) ? c.push(b) : a.index = e;
      if (b = directives(a)) {
        return c.push(b), e = a.index, ignored(a) || (a.index = e), function(a) {
          return {
            kind: a.tag,
            variable: a[0],
            type: a[1],
            defaultValue: a[2].tag ? void 0 : a[2],
            directives: a[2].tag ? a[2] : a[3]
          };
        }(tag(c, "VariableDefinition"));
      }
    }
  }
  a.index = d;
}, _VariableDefinitionSet_expression = _pattern(/[(]/), _VariableDefinitionSet_expression2 = _pattern(/[)]/), _FragmentDefinition_expression = _pattern(/fragment/), fragmentDefinition = function(a) {
  var b, d = a.index, c = [];
  if (_exec(a, _FragmentDefinition_expression) && ignored(a) && (b = name(a)) && (c.push(b), 
  ignored(a) && (b = typeCondition(a)) && (c.push(b), b = directives(a))) && (c.push(b), 
  b = selectionSet(a))) {
    return c.push(b), function(a) {
      return {
        kind: a.tag,
        name: a[0],
        typeCondition: a[1],
        directives: a[2],
        selectionSet: a[3]
      };
    }(tag(c, "FragmentDefinition"));
  }
  a.index = d;
}, _OperationDefinition_expression = _pattern(/query|mutation|subscription/), operationDefinition = function(a) {
  var b, d = a.index, c = [], e = a.index;
  ignored(a) || (a.index = e);
  if (b = _exec(a, _OperationDefinition_expression)) {
    if (c.push(b), e = a.index, ignored(a) || (a.index = e), (b = name(a)) ? c.push(b) : a.index = e, 
    e = a.index, ignored(a) || (a.index = e), e = a.index, (b = function(a) {
      var d = a.index, b = [];
      if (_exec(a, _VariableDefinitionSet_expression)) {
        var c = a.index;
        ignored(a) || (a.index = c);
        var e = 0;
        a: for (;;e++) {
          var f = a.index;
          if (c = varDefinition(a)) {
            b.push(c);
          } else {
            if (e) {
              a.index = f;
              break a;
            }
            a.index = d;
            return;
          }
        }
        if (_exec(a, _VariableDefinitionSet_expression2)) {
          return c = a.index, ignored(a) || (a.index = c), tag(b, "VariableDefinitionSet");
        }
      }
      a.index = d;
    }(a)) ? c.push(b) : a.index = e, b = directives(a)) {
      if (c.push(b), b = selectionSet(a)) {
        return c.push(b), function(a) {
          var d = 1;
          return {
            kind: a.tag,
            operation: a[0],
            name: 5 === a.length ? a[d++] : void 0,
            variableDefinitions: "VariableDefinitionSet" === a[d].tag ? a[d++] : null,
            directives: a[d++],
            selectionSet: a[d]
          };
        }(tag(c, "OperationDefinition"));
      }
    }
  }
  a.index = d;
}, _Document_transform = function(a) {
  return a.length ? {
    kind: a.tag,
    definitions: a
  } : void 0;
}, parse$1 = function(a) {
  return function(d) {
    return a({
      input: d,
      index: 0
    });
  };
}((function(a) {
  var b, d = a.index, c = [];
  var e = a.index;
  if (b = function(a) {
    var d = a.index, b = [];
    var c = a.index;
    ignored(a) || (a.index = c);
    if (c = selectionSet(a)) {
      return b.push(c), function(a) {
        return {
          kind: a.tag,
          operation: "query",
          name: void 0,
          variableDefinitions: [],
          directives: [],
          selectionSet: a[0]
        };
      }(tag(b, "OperationDefinition"));
    }
    a.index = d;
  }(a)) {
    return c.push(b), _Document_transform(tag(c, "Document"));
  }
  a.index = e;
  var f = 0;
  a: for (;;f++) {
    e = a.index;
    var g = c.length;
    b: {
      var h = a.index;
      if (b = operationDefinition(a)) {
        c.push(b);
        break b;
      } else {
        c.length = g, a.index = h;
      }
      if (b = fragmentDefinition(a)) {
        c.push(b);
      } else {
        if (f) {
          a.index = e;
          break a;
        }
        c.length = g;
        a.index = d;
        return;
      }
    }
  }
  return _Document_transform(tag(c, "Document"));
}));

exports.parse = parse$1;
//# sourceMappingURL=graphql-parse-core.js.map
